SystemOrganization addCategory: #'SCouchDB-Application-Test'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums-View-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums-Delete-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums-Edit-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums-Add-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Albums-Login-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Test-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application'!
SystemOrganization addCategory: #'SCouchDB-Application-Evently'!
SystemOrganization addCategory: #'SCouchDB-Application-Evently-Account'!

!SCouchDatabase methodsFor: '*SCouchDB-Application' stamp: 'JesusMari 8/25/2012 12:30'!
arrayOfMultipartsFrom:content
|anArray text  first rStream |

anArray := OrderedCollection new.

first:= 	'content-type: application/json' ,String crlf,String crlf , (self utf8Encode: content asJsonString).
rStream:= ReadStream on:first from:1 to:first size.
anArray add:rStream.

(content at:'_attachments') do:[:attch|
	anArray  add:attch stream	
].

^anArray



		

! !

!SCouchDatabase methodsFor: '*SCouchDB-Application' stamp: 'JesusMariAguirre 5/16/2012 10:23'!
boundary
^ adaptor boundary! !

!SCouchDatabase methodsFor: '*SCouchDB-Application' stamp: 'JesusMariAguirre 5/14/2012 09:49'!
documentCurrentRevAt: id 

	| response result |
	(id asString beginsWith: '_') 
	ifTrue: 
	[response := adaptor head: self namePrefix , id asString]	
	ifFalse:
	[response := adaptor head: self namePrefix , id asString encodeForHTTP].

	result := response etag. 
	
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*SCouchDB-Application' stamp: 'JesusMari 4/9/2012 14:02'!
documentRevisionsAt: id 

	| response result |
	response := adaptor get: self namePrefix , id asString ,
		'?revs=true'.

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*SCouchDB-Application' stamp: 'JesusMari 4/9/2012 14:03'!
documentRevsInfoAt: id 

	| response result |
	
	response := adaptor get: self namePrefix , id asString  encodeForHTTP ,
		'?revs_info=true' .

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchHTTPResponse methodsFor: '*SCouchDB-Application' stamp: 'JesusMari 4/9/2012 12:33'!
etag

	| tmp |
	tmp:= header at: 'etag' ifAbsent: [nil].
	tmp ifNil:[^tmp] ifNotNil:[^tmp withoutQuoting]! !

!JsonObject methodsFor: '*scouchdb-Application' stamp: 'JesusMariAguirre 5/14/2012 15:41'!
addAttachmentAt: name put:anAttachment
self at:'_attachments' ifAbsent:[ self at:'_attachments' put:JsonObject new].
(self at: '_attachments') at:name put:anAttachment
! !

!JsonObject methodsFor: '*scouchdb-Application' stamp: 'JesusMariAguirre 5/14/2012 15:42'!
removeAttachment:anAttachment
^(self at:'_attachments') removeKey:anAttachment ifAbsent:[nil]! !

JsonObject subclass: #SCouchDBAttachment
	instanceVariableNames: 'name fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application'!

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 13:22'!
fromFile:aFileName
^self fromFile:aFileName includeDoc:true ! !

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/27/2012 10:25'!
fromFile:aFileName includeDoc:aBoolean
| attch aStream|

attch:=self new.
aStream := StandardFileStream readOnlyFileNamed: aFileName .
aBoolean ifFalse:[attch contentLength: aStream size].
attch contentType: (MIMEDocument guessTypeFromName: aFileName) asString.
attch fileName:aFileName.
aBoolean ifFalse:[
	attch at:'follows' put:true.
	attch removeKey:'data'].
aStream close.
^attch! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:50'!
at:obj
(obj='data') 
ifTrue:[^self data].
^super at:obj
! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength
^self at:'length'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength:lenght
self at:'length' put:lenght! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType
^self at:'content_type'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType:type
self at:'content_type' put:type! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:39'!
data

        ^ (Base64MimeConverter mimeEncode: self stream multiLine: false) contents! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName
^fileName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName:aName
fileName:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:47'!
initialize:size
super initialize:size.
self at:'data' put:nil.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 11:11'!
jsonWriteOn: aStream

	| needComma |
	needComma := false.
	aStream nextPut: ${.
	self associationsDo: [ :assoc |
		needComma
			ifTrue: [ aStream nextPut: $, ]
			ifFalse: [ needComma := true ].
		assoc key jsonWriteOn: aStream.
		aStream nextPut: $:.
		(assoc key  = 'data') ifTrue:[ self data jsonWriteOn: aStream ]
							 ifFalse:[assoc value jsonWriteOn: aStream]
		 ].
	aStream nextPut: $}.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name
^name! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name:aName
name:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 19:16'!
stream
| aStream a |
a:=StandardFileStream readOnlyFileNamed:fileName .
a binary.
^a

! !

JsonObject subclass: #SCouchEvently
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently'!

SCouchEvently class
	instanceVariableNames: 'instance'!

SCouchEvently class
	instanceVariableNames: 'instance'!

SCouchEvently subclass: #AddformAddFooter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Add-Evently'!

AddformAddFooter subclass: #AddfooterInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Add-Evently'!

!AddfooterInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 14:45'!
initialize
super initialize.

self addTriggerToSelector: '#addCancelButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addCancel'');
			}'. 
			
self addTriggerToSelector: '#addConfirmButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addConfirm'');
			}'. 

! !

SCouchEvently subclass: #AddformAlbumAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Add-Evently'!

AddformAlbumAdd subclass: #AddformAddCancel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Add-Evently'!

!AddformAddCancel methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 15:18'!
render
^'function( event ){
	   $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    }'! !

AddformAlbumAdd subclass: #AddformAddConfirm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Add-Evently'!

!AddformAddConfirm methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 15:19'!
render
^'function(e){
		var document = {};
            document.artist = $("input#addArtistField").val();
            document.title = $("input#addTitleField").val();
            document.description = $("textarea#addDescriptionField").val();
            document.creation_date = ( new Date() ).getTime();
            $.albums.saveDocument( document, {
                    success: function() {
                           $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
                    },
                    error: function( status, error, reason ) {
                        alert( "Cannot save new document.\n" + status + ", " + reason + ", " + error );
                    }
              });
}'! !

SCouchEvently subclass: #DeleteformAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Delete-Evently'!

DeleteformAlbumDelete subclass: #DeleteformDeleteCancel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Delete-Evently'!

!DeleteformDeleteCancel methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/8/2012 08:58'!
render
^'function( event ){
        var docId = $("#deleteFooter").data("identity");
        $.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
        return false;
    }'! !

DeleteformAlbumDelete subclass: #DeleteformDeleteConfirm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Delete-Evently'!

!DeleteformDeleteConfirm methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/9/2012 10:17'!
render
^'function( event ){
        var docId = $("#deleteFooter").data("identity");
        // First open doc based on ID in order to get the  latest _revision.
        $db.openDoc( docId, {
            success: function( document ){
                // Then use the opened doc as reference to remove.
                $.albums.deleteDocument( document, {
                    success:function(){
                        $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
                    },
             	   error:function( status, error, reason ){
                        alert( "Could not remove document with id: " + docId + "\n" + reason );
                    }
                });
            },
            error:function(){
                alert( "Could not find document with id: " + docId );
            }
        });
        return false;
    }'! !

SCouchEvently subclass: #DeleteformDeleteFooter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Delete-Evently'!

DeleteformDeleteFooter subclass: #DeletefooterInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Delete-Evently'!

!DeletefooterInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/6/2012 18:02'!
initialize
super initialize.

self addTriggerToSelector: '#dialogCloseButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''deleteCancel'');
			}'. 
			
self addTriggerToSelector: '#deleteCancelButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''deleteCancel'');
			}'. 
			
self addTriggerToSelector: '#deleteConfirmButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''deleteConfirm'');
			}'. 

! !

SCouchEvently subclass: #EditformAlbumEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

EditformAlbumEdit subclass: #EditformEditCancel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

!EditformEditCancel methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 14:46'!
render
^'function( event ){
        var docId = $("#albumEditPage").data("identity");
        $.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
    }'! !

EditformAlbumEdit subclass: #EditformEditConfirm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

!EditformEditConfirm methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/11/2012 17:48'!
render
^'function(e){
	var currentAlbum= $$(this).currentAlbum;
	currentAlbum.artist = $("input#artistField").val();
	currentAlbum.title = $("input#titleField").val();
	currentAlbum.description = $("textarea#descriptionField").val();

	$.albums.saveDocument( currentAlbum, {	
			success: function( response )  {
				$.mobile.changePage( "/albums/_design/albums/_show/album/" + currentAlbum._id,"flip", true, true );
			},
			error: function( status, error, reason ) {
				alert( "Cannot save document: " + document._id + "\n" + reason );
			}
		});
	
}'! !

EditformAlbumEdit subclass: #EditformInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

!EditformInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/11/2012 17:19'!
data
^'function(e){
	var docId = $("#albumEditPage").data("identity");
	var currentAlbum;
	$db.openDoc( docId, {
					success: function( document ) {
						currentAlbum=document;
						
					},
					error: function() {
						alert( "Cannot open document: " + docId );
					}
				},
				{async:false});
	$$(this).currentAlbum = currentAlbum;			

	return  $$(this).currentAlbum;
	
}'! !

!EditformInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/10/2012 09:26'!
mustache
^'<form id="albumform" action="#" method="get" >
  			<div data-role="fieldcontain"> 
	        	<label for="artist">Artist:</label> 
	   	    	<input id="artistField" name="artist" type="text" value="{{artist}}" />
			</div>
			<div data-role="fieldcontain"> 
	        	<label for="title">Title:</label> 
	   	    	<input id="titleField" name="title" type="text" value="{{title}}" />
			</div>
			<div data-role="fieldcontain"> 
				<label for="description">Description:</label> 
				<textarea id="descriptionField" name="description" cols="40" rows="8">{{description}}</textarea> 
			</div>
		</form>'! !

SCouchEvently subclass: #EditformEditFooter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

EditformEditFooter subclass: #EditfooterInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Edit-Evently'!

!EditfooterInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/11/2012 17:51'!
initialize
super initialize.

self addTriggerToSelector: '#editCancelButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''editCancel'');
			}'. 
			
self addTriggerToSelector: '#editConfirmButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''editConfirm'');
			}'. 

! !

SCouchEvently subclass: #EventlyAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlyAccount subclass: #EventlyAdminParty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyAdminParty methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:45'!
mustache
^'<p><strong>Admin party, everyone is admin!!</strong> Fix this in <a href="/_utils/index.html">Futon</a> before proceeding.</p>'! !

EventlyAccount subclass: #EventlyDoLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyDoLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:24'!
render
^'function(e, name, pass) {
  var elem = $(this);
  $.couch.login({
    name : name,
    password : pass,
    success : function(r) {
      elem.trigger("_init")
    }
  });      
}'! !

EventlyAccount subclass: #EventlyDoLogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyDoLogout methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:25'!
render
^'function() {
  var elem = $(this);
  $.couch.logout({
    success : function() {
      elem.trigger("_init");
    }
  });
}'! !

EventlyAccount subclass: #EventlyDoSignup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyDoSignup methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:25'!
render
^'function(e, name, pass) {
  var elem = $(this);
  $.couch.signup({
    name : name
  }, pass, {
    success : function() {
      elem.trigger("doLogin", [name, pass]);
    }
  });
}'! !

EventlyAccount subclass: #EventlyInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:24'!
render
^'function() {
  var elem = $(this);
  $$(this).userCtx = null;
  $.couch.session({
    success : function(r) {
      var userCtx = r.userCtx;
      if (userCtx.name) {
        elem.trigger("loggedIn", [r]);
      } else if (userCtx.roles.indexOf("_admin") !!= -1) {
        elem.trigger("adminParty");
      } else {
        elem.trigger("loggedOut");
      };
    }
  });
}'! !

EventlyAccount subclass: #EventlyLoggedIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlyLoggedIn subclass: #Evently3After
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!Evently3After methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:42'!
render
^'function(e, r) {
  $$(this).userCtx = r.userCtx;
  $$(this).info = r.info;
};'! !

!EventlyLoggedIn methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:41'!
data

^'function(e, r) {
  return {
    name : r.userCtx.name,
    uri_name : encodeURIComponent(r.userCtx.name),
    auth_db : encodeURIComponent(r.info.authentication_db)
  };
}'! !

!EventlyLoggedIn methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 09:30'!
initialize

self addTriggerToSelector: 'a[href=#logout]' on:'click'  do:(Array with:'doLogout') ! !

!EventlyLoggedIn methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:40'!
mustache
^'<span>Welcome 
<a target="_new" href="/_utils/document.html?{{auth_db}}/org.couchdb.user%3A{{uri_name}}">{{name}}</a>!! 
<a href="#logout">Logout?</a>
</span>'! !

EventlyAccount subclass: #EventlyLoggedOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyLoggedOut methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 09:31'!
initialize
self addTriggerToSelector: 'a[href=#signup]' on: 'click' do:(Array with:'signupForm').
self addTriggerToSelector: 'a[href=#login]' on: 'click' do:(Array with:'loginForm').! !

!EventlyLoggedOut methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:37'!
mustache
^'<a href="#signup">Signup</a> or <a href="#login">Login</a>'! !

EventlyAccount subclass: #EventlyLoginForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlyLoginForm subclass: #Evently2After
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!Evently2After methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:34'!
render
^'function() {
  $("input[name=name]", this).focus();
}'! !

!EventlyLoginForm methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 09:31'!
initialize

self addTriggerToSelector: 'a[href=#signup]' on:'click'  do:(Array with:'signupForm').
self addTriggerToSelector: 'form' on:'submit' 
	do:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doLogin'', [name, pass]);
  		return false;
	}'
	

! !

!EventlyLoginForm methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:33'!
mustache
^'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Login">
  <a href="#signup">or Signup</a>
</form>'! !

EventlyAccount subclass: #EventlySignupForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlySignupForm subclass: #EventlyAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EventlyAfter methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:27'!
render
^'function() {
  $("input[name=name]", this).focus();
}'! !

!EventlySignupForm methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 09:31'!
initialize

self addTriggerToSelector: 'a[href=#login]' on:'click'  do:(Array with:'loginForm').
self addTriggerToSelector: 'form' on:'submit' 
	do:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doSignup'', [name, pass]);
  		return false;
	}'
! !

!EventlySignupForm methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:28'!
mustache
^'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Signup">
  <a href="#login">or Login</a>
</form>
'! !

SCouchEvently subclass: #EventlyItems
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlyItems subclass: #ItemsChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!ItemsChanges methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:07'!
data
^ 'function(data) {
  // $.log(data)
  var p;
  return {
    items : data.rows.map(function(r) {
      p = (r.value && r.value.profile) || {};
      p.message = r.value && r.value.message;
      return p;
    })
  }
};'! !

!ItemsChanges methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:08'!
mustache
^'<p>Customize this format here: <tt>ddoc.evently.items._changes.mustache</tt></p>
<h3>Recent Messages</h3>
<ul>
  {{#items}}
    <li>
      <div class="avatar">
        {{#gravatar_url}}<img src="{{gravatar_url}}" alt="{{name}}"/>{{/gravatar_url}}
        <div class="name">
          {{nickname}}
        </div>
      </div>
      <p>{{message}}</p>
      <div style="clear:left;"></div>
    </li>
  {{/items}}
</ul>
<p><em>Protip:</em> If you setup continuous replication between this database and a remote one, this list will reflect remote changes in near real-time.</p>
<p>This would be a good place to add pagination.</p>'! !

!ItemsChanges methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:13'!
query
"{
  view : recent-items,
  descending : true,
  limit : 50
}"
|q|
q:= SCouchEventlyQuery new.
q view:'recent-items'.
q at:'descending' put: true.
q at:'limit' put: 50.
^q! !

SCouchEvently subclass: #EventlyProfile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EventlyProfile subclass: #EProfLoggedIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EProfLoggedIn methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 19:57'!
render
^'function(e, r) {
  	var userCtx = r.userCtx;
  	var widget = $(this);
  	// load the profile from the user doc
  	var db = $.couch.db(r.info.authentication_db);
  	var userDocId = "org.couchdb.user:"+userCtx.name;
  	db.openDoc(userDocId, {
    		success : function(userDoc) {
      		var profile = userDoc["couch.app.profile"];
      		if (profile) {
        		// we copy the name to the profile so it can be used later
        		// without publishing the entire userdoc (roles, pass, etc)
        		profile.name = userDoc.name;
        		$$(widget).profile = profile;
        		widget.trigger("profileReady", [profile]);
      		} else {
        		widget.trigger("noProfile", [userCtx]);
      	}
    	}
  });
}'! !

EventlyProfile subclass: #EProfLoggedOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EProfLoggedOut subclass: #EProfAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EProfAfter methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:18'!
render
^'function() {
  $$(this).profile = null;
};'! !

!EProfLoggedOut methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:19'!
mustache
^'<p>Please log in to see your profile.</p>'! !

EventlyProfile subclass: #EProfNoProfile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EProfNoProfile methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:20'!
data
^'function(e, userCtx) {
  return userCtx;
}'! !

!EProfNoProfile methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:22'!
initialize
self addTriggerToSelector: 'form' on:'submit'  
do:'function() {
  var md5 = $$(this).app.require("vendor/couchapp/lib/md5");
  
  // TODO this can be cleaned up with docForm?
  // it still needs the workflow to edit an existing profile
  var name = $("input[name=userCtxName]",this).val();
  var newProfile = {
    rand : Math.random().toString(), 
    nickname : $("input[name=nickname]",this).val(),
    email : $("input[name=email]",this).val(),
    url : $("input[name=url]",this).val()
  }, widget = $(this);

  // setup gravatar_url
  if (md5) {
    newProfile.gravatar_url = ''http://www.gravatar.com/avatar/''+md5.hex(newProfile.email || newProfile.rand)+''.jpg?s=40&d=identicon'';    
  }

  // store the user profile on the user account document
  $.couch.userDb(function(db) {
    var userDocId = "org.couchdb.user:"+name;
    db.openDoc(userDocId, {
      success : function(userDoc) {
        userDoc["couch.app.profile"] = newProfile;
        db.saveDoc(userDoc, {
          success : function() {
            newProfile.name = userDoc.name;
            $$(widget).profile = newProfile;
            widget.trigger("profileReady", [newProfile]);
          }
        });
      }
    });
  });
  return false;
}
' ! !

!EProfNoProfile methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:21'!
mustache
^'<form>
  <p>Hello {{name}}, Please setup your user profile.</p>
  <label for="nickname">Nickname 
    <input type="text" name="nickname" value=""></label>
  <label for="email">Email (<em>for <a href="http://gravatar.com">Gravatar</a></em>)
    <input type="text" name="email" value=""></label>
  <label for="url">URL 
    <input type="text" name="url" value=""></label>
  <input type="submit" value="Go &rarr;">
  <input type="hidden" name="userCtxName" value="{{name}}" id="userCtxName">
</form>'! !

EventlyProfile subclass: #EProfProfileReady
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

EProfProfileReady subclass: #EProf2After
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Account'!

!EProf2After methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:25'!
render
^'function(e, p) {
  $$(this).profile = p;
};'! !

!EProfProfileReady methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:24'!
data
^'function(e, p) {
  return p
}
'! !

!EProfProfileReady methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/30/2012 08:45'!
initialize
self addTriggerToSelector: 'form' 
on: 'submit' 
do: 'function() {
  var form = $(this);
  var fdoc = form.serializeObject();
  fdoc.created_at = new Date();
  fdoc.profile = $$("#profile").profile;
  $$(this).app.db.saveDoc(fdoc, {
    success : function() {
      form[0].reset();
    }
  });
  return false;
};'! !

!EProfProfileReady methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/22/2012 10:25'!
mustache 
^'<div class="avatar">
  {{#gravatar_url}}<img src="{{gravatar_url}}"/>{{/gravatar_url}}
  <div class="name">
    {{nickname}}
  </div>
</div>
<p>Hello {{nickname}}!!</p>
<div style="clear:left;"></div>'! !

SCouchEvently subclass: #LoginformLoginCtrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Login-Evently'!

LoginformLoginCtrl subclass: #DialogInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Login-Evently'!

!DialogInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/7/2012 17:09'!
initialize
super initialize.

self addTriggerToSelector: '#dialogCloseButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''loginCancel'');
			}'. 
			
self addTriggerToSelector: '#loginConfirmButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''loginConfirm'');
			}'. 
! !

SCouchEvently subclass: #LoginformLoginDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Login-Evently'!

LoginformLoginDialog subclass: #DialogLoginCancel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Login-Evently'!

!DialogLoginCancel methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/9/2012 08:42'!
render
^'function (e){$("#loginDialog").dialog(''close'');}'! !

LoginformLoginDialog subclass: #DialogLoginConfirm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-Login-Evently'!

!DialogLoginConfirm methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/9/2012 09:42'!
render
^'function(e,form){
	var username = $( "#username" ).attr(''value'');
  	var password = $( "#password" ).attr(''value'');
	//var uievent = ( ops.state == 0 ) ? "login" : "signup";
	$.albums.logIn(username,password);
	$(''#loginDialog'').dialog(''close'');
	}
'! !

!SCouchEvently class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/28/2012 11:52'!
instance
 instance:=self new.

self subclasses do:[:aSubClass|
		aSubClass initialize.
		instance addEvently: aSubClass instance.
	].	
(instance respondsTo:#mustache) ifTrue:[instance at:'mustache' put: instance mustache].
(instance respondsTo:#data) ifTrue:[instance at:'data' put:instance data].	
(instance respondsTo:#query) ifTrue:[instance at:'query' put: instance query].

instance initialize.
^instance! !

!SCouchEvently methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 19:37'!
addEvently:anEventlyObject
|selectors eventName cutOn  i|

eventName:= anEventlyObject class asString.
i:=1.
cutOn:=1.
eventName do:[:aChar|
	(aChar isUppercase and: [i > 1 and:[cutOn=1]]) ifTrue:[
		cutOn:= i.
		
		].
	i:=i+1.
	].

eventName:= eventName copyFrom: cutOn to: eventName size. 
eventName at: 1 put: (eventName at: 1) asLowercase.
(eventName = 'init') ifTrue:[eventName:='_init'].
(eventName = 'changes') ifTrue:[eventName:='_changes'].
(anEventlyObject respondsTo:#render)
	ifTrue:[
		self at:(eventName) put: anEventlyObject render]	
	ifFalse:[
		self at:(eventName) put: anEventlyObject ].

! !

!SCouchEvently methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/21/2012 18:58'!
addTriggerToSelector:aSelector on:event do:jscriptFunction
|selectors|

selectors:= self at:'selectors' ifAbsent:[self at:'selectors' put:(JsonObject new)].

selectors at:aSelector put: (
	JsonObject fromAssociations: {
			event -> jscriptFunction.
			}) 

! !

!SCouchEvently methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2012 17:29'!
init
^self at:'_init'! !

!SCouchEvently methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2012 12:02'!
selectors
"this method has to a json selectors object
^ selector
Example:
^'
{
	'a': {'click' : 'function(){ alert('click on me');}'
}'"

self at:'selectors' ifAbsent:[^nil]


! !

SCouchEvently subclass: #TutorialChoices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

TutorialChoices subclass: #ChoicesInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!ChoicesInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 19:39'!
initialize
super initialize.

self addTriggerToSelector: 'a[href=#cheese]' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addTopping'',''cheese'');
			}'. 
			
self addTriggerToSelector: 'a[href=#bacon]' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addTopping'',''bacon'');
			}'. 
self addTriggerToSelector: 'a[href=#chili]' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addTopping'',''chili'');
			}'. 
self addTriggerToSelector: 'a[href=#tomatoes]' 
	on:'click'  
	do:'function(){
			$(this).trigger(''addTopping'',''tomatoes'');
			}'. ! !

!ChoicesInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:50'!
mustache
	"this method has to return a mustache tamplate
^ template
Example:
^'<p>Items server via evently<p>'"

^ '
<p>You won a free topping!! what would you like it to be?</p>
<ul>
	<li><a href="#cheese">Cheese</a></li>
	<li><a href="#bacon">bacon</a></li>
	<li><a href="#chili">chili</a></li>
	<li><a href="#tomatoes">tomatoes</a></li>
</ul>'! !

SCouchEvently subclass: #TutorialExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

TutorialExamples subclass: #ExampleInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!ExampleInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:51'!
data
^'function (data){
return { examples: data.rows};
}
'
! !

!ExampleInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:51'!
mustache 
^'<p>A feq examples that could inspire you:</p>
<ul>
{{#examples}}
	<li>{{value}}</li>
{{/examples}}
</ul>
'! !

!ExampleInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:51'!
query
|q|
q:= SCouchEventlyQuery new.
q view:'toppings'.
q limit: 2.
^q! !

SCouchEvently subclass: #TutorialItems
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

TutorialItems subclass: #ItemsAddTopping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!ItemsAddTopping methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 19:32'!
render
^'function(e,topping){
	$$(this).toppings.push({"top":topping});
	$(this).trigger(''topping'');
}'! !

TutorialItems subclass: #ItemsInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!ItemsInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:31'!
data
^'function(e){
	$$(this).toppings = [];
}
'! !

!ItemsInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/19/2012 20:31'!
mustache
	"this method has to return a mustache tamplate
^ template
Example:
^'<p>Items server via evently<p>'"

^'
<p>Items served by evently<p>
'	! !

TutorialItems subclass: #ItemsTopping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!ItemsTopping methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 19:32'!
data
	"this method has to a  return ajscript function (e,event)
^ selector
Example:
^'function (e,topping)
{
	return {topping: topping};
}'"

^'function (e,topping){
	return {toppings : $$(this).toppings};
}'! !

!ItemsTopping methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 02:56'!
mustache
	"this method has to return a mustache tamplate
^ template
Example:
^'<p>Items server via evently<p>'"

^'<p>Oh, you want on your pizza</p>
<ul>
{{#toppings}}
	<li>{{top}}</li>
{{/toppings}}
</ul>'
! !

SCouchEvently subclass: #ViewformAlbumFooter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

ViewformAlbumFooter subclass: #FooterInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

!FooterInit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/6/2012 10:29'!
initialize
super initialize.

self addTriggerToSelector: '#deleteButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''albumDelete'');
			}'. 
			
self addTriggerToSelector: '#editButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''albumEdit'');
			}'. 
self addTriggerToSelector:'#letButton' 
	on:'click'  
	do:'function(){
			$(this).trigger(''albumLet'');
			}'. 
! !

SCouchEvently subclass: #ViewformAlbumView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

ViewformAlbumView subclass: #ViewAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

!ViewAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/8/2012 09:03'!
render
^'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-delete/" + docId, "slideup", false, false );
		}'! !

ViewformAlbumView subclass: #ViewAlbumEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

!ViewAlbumEdit methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/8/2012 09:13'!
render
^'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-edit/" + docId, "flip", false, true )
		}'! !

ViewformAlbumView subclass: #ViewAlbumLet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums-View-Evently'!

!ViewAlbumLet methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/16/2012 11:26'!
render
^'function(e,data){
		var docId = $("#albumcontent").data("identity");
		// Change page.
		 $.albums.letDocument(docId, {
			"success": function(){$.mobile.changePage( "/albums/_design/albums/_show/album-users/" + docId, "flip", false, true );}
		});
}'! !

JsonObject subclass: #SCouchEventlyQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently'!

!SCouchEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:52'!
limit: anInteger
self at:'limit' put: anInteger! !

!SCouchEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:51'!
view: aViewName
self at:'view' put:aViewName! !

SCouchDBAppWrapper subclass: #SCouchDBApp
	instanceVariableNames: 'database dbAdaptor appName runner includeDocs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application'!

SCouchDBApp subclass: #Albums
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Albums'!

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/25/2012 11:18'!
initEvently

self addEvently: ViewformAlbumFooter.
self addEvently: ViewformAlbumView.
self addEvently: DeleteformAlbumDelete.
self addEvently: DeleteformDeleteFooter.
self addEvently: LoginformLoginCtrl.
self addEvently: LoginformLoginDialog.
self addEvently: EditformEditFooter.
self addEvently: EditformAlbumEdit.
self addEvently: AddformAddFooter.
self addEvently: AddformAlbumAdd 
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 20:19'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc user)= (req userCtx name)) 
	].
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/22/2012 18:32'!
initLists
self addListAt:'albumIndex' put:
[:head :req|	
self provides:'html' with:[:aReq :aHead|
	|doc stash albums template| 

	albums:=OrderedCollection new.
	[(doc:=self getRow ) isNil] whileFalse:[
		albums add: doc value.
		].

	template:=self templates at:'albumindex'.
	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.
	
	self send: (Mustache toHtml:template view:stash partials: (self partials)).
	]
]! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/22/2012 17:19'!
initShows
self addShowAt: 'album-login' put: [:aDoc :req|
	|template|

	template:=self templates at:'albumlogin'.
	Mustache toHtml:template view:aDoc partials: (self partials).		
	].

self addShowAt: 'album' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user'-> (aDoc at:'user').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-delete' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumdelete'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].


self addShowAt: 'album-edit' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'albumedit'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-users' put: [:aDoc :req|
	| template adminUsers userCollection stash|
	
	adminUsers:=((req at:'secObj') at:'admins') at:'names'.
	userCollection:=OrderedCollection new.
	adminUsers do:[:anUserName|
		userCollection add: (
			JsonObject fromAssociations: {'userName'->anUserName})
		].

	
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id').
		'loans'->(aDoc at:'loans').
		'admins'->(userCollection asArray)
	}.
	template:=self templates at:'albumusers'.

	Mustache toHtml:template view:stash partials: self partials.		
	].

self addShowAt: 'album-add' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumadd'.
	Mustache toHtml:template view:stash partials: (self partials).		
	].! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/21/2012 16:29'!
initUpdateHandler
self addUpdateHandlerAt: 'setNewUser' put:[:aDoc :req|
	|template stash loans|
	
	loans:=aDoc at:'loans'.
	loans ifNil:[loans:=OrderedCollection new]
		  ifNotNil:[loans:=OrderedCollection newFrom:loans].
	loans add:(JsonObject fromAssociations:{
							'user' -> ( req query newuser).
							'date' -> (DateAndTime now asString).
							}).
	aDoc at:'loans'  put:loans.
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user' -> (aDoc at:'user').
		'document' -> (aDoc at:'_id').
	}.
	
	Array with:aDoc with:(Mustache toHtml:template view:stash partials: (self partials))
	].! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/22/2012 18:36'!
initValidator


self validateDocUpdate: [:newDoc :savedDoc :userContext|
| isDeletingWithoutPermission isUpdatingWithoutPermission isAlbumUser|
	isDeletingWithoutPermission:=false.
	isUpdatingWithoutPermission:=false.
	isAlbumUser:=(self isAdmin or:[ self userIs:'albums-user']).

	(userContext at:'name' ) 
	ifNil:[ ((UnauthorizedException new) messageText:'You need to be logged in order to do that.') signal]
	ifNotNil:[
		(isAlbumUser) ifFalse:[((ForbiddenException new) messageText: 'You do not have proper access to edit this document.') signal]
		].
	isDeletingWithoutPermission:=((newDoc at:'_deleted') notNil) and:[ (savedDoc user = userContext name) not].
	isUpdatingWithoutPermission:=(newDoc user = userContext name) not or:[
		savedDoc 
			ifNil:[false] 
			ifNotNil:[
				(newDoc user = savedDoc user) not.
			]].
	
	((self isAdmin not) and:[isDeletingWithoutPermission] ) 
	ifTrue:[
		
		((ForbiddenException new ) messageText:'Only the creator of this document has permission to delete') signal
	] ifFalse:[
		((self isAdmin  not) and:[isUpdatingWithoutPermission and:[(newDoc at:'_deleted') isNil ]] )
		 ifTrue:[
				((ForbiddenException new) messageText: 'Only the creator of this document has permission to update') signal
				] 
		ifFalse:[
				((newDoc at:'_deleted') = true) 
				ifFalse:[	self required:'user']
			]	
	]
]
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/25/2012 11:49'!
initViews.
self addViewAt:'albums'	
	put:
	[:doc|
		self emit: doc key:(doc at:'creation_date')
	].

self addViewAt:'recent-items'	
	put:
	[:doc|
		self emit: (doc at:'creation_date') key:(doc at:'creation_date')
	]
	reduce:'sum'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 09:47'!
initialize
super initialize.
self appName: 'albums'.
self language: 'smalltalk'.
self initViews.
self initShows.
self initLists.
self initEvently.
self initValidator.
self initUpdateHandler.
self initFilters.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'95t5boru'.
self upload.

! !

SCouchDBApp subclass: #HelloViewServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test'!

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 18:55'!
initEvently
self addEvently: EventlyAccount. 
self addEvently: EventlyProfile.
self addEvently: EventlySignupForm.
self addEvently: EventlyItems. ! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:16'!
initViews
self addViewAt:'recent-items'	
	put:
	[:doc|
		((doc at:'type')='users') ifTrue:[
			self emit:doc key:(doc at:'_id')
		]
	].! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/31/2012 01:34'!
initialize
super initialize.
self initViews.
self initEvently.

self importVendorFilesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\vendor\'.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'95t5boru'.
self upload.
! !

SCouchDBApp subclass: #SCouchAppTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test'!

!SCouchAppTest class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/28/2012 11:02'!
test
|aDoc db adaptor docArray docs |
self halt.

docs:= Array 
		with:(JsonObject fromAssociations:{	'artist'->'Thin Lizzy' .
														'title'->'Fighting'.
														'description'->'Bona-fide Rock classic'   											
											})					
		with:(JsonObject fromAssociations:   { 	'artist'->'David Bowie' .
														'title'->'Honky Dory'.
														'description'->'Doesn''t get much better than this'  
											}) .


adaptor:=SCouchDBAdaptor new 
	host: '127.0.0.1' 
	port: 5984 
	userName:'admin' 
	password:'95t5boru'.
db:= adaptor ensureDatabase: 'albums'.


docs do:[:d|
	db documentPut: d.
	]



"db deleteDocument: '1234556789A' revision:'1-67cb06c9c5c2ebd05c16fdd4a8b77528'.

docArray Nothing more expected ->:=db documentRevsInfoAt: '1234556789A'.
Transcript show: docArray asString.
Transcript show: adaptor users asString.
Transcript show: adaptor uuids asString.

docArray do:[:aDoc|
	Transcript show: aDoc asString.
]   "! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 09:55'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc owner)= (req userCtx name)) 
		ifTrue:[true]
		ifFalse:[false]
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/5/2012 17:23'!
initLists
self addListAt:'argumentList' put:
[:head :req|	
self provides:'html' with:[:aReq :aHead|
	|doc|
	[(doc:=self getRow ) isNil] whileFalse:[
		|val|
		val:=doc value.
		self sendOnCanvas:[:html|
			html heading level:2;with: (val aTag).
			html paragraph: (val aDescription).
			].
		]
	]
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 17:22'!
initShows
self addShowAt:'helloWorld' put:
[:aDoc :req|
	self sendOnCanvas:[:html|
			html html:'
			<head>
				<title>CouchDB test</title>
				<meta http-equiv="Content-type" content="text/html; chanset=utf-8"/>
				<script src= "/_utils/script/json2.js"></script>
				<script src= "/_utils/script/sha1.js"></script>
				<script src= "/_utils/script/jquery.js?1.4.2"></script>
				<script src= "/_utils/script/jquery.couch.js?0.11.0"></script>
				<script src= "/_utils/script/jquery.dialog.js?0.11.0"></script>
			</head>'.
			html render: (JQSCouchDBTest new)
			].
	].


self addShowAt:'redirection' put:
[:aDoc :req|	
self redirectTo:'/_utils'
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/9/2012 20:02'!
initUpdates
self addUpdateHandlerAt:'argumentsToPepe'	
	put:
	[:doc :req|
		(doc owner) 
		ifNil:[Array with:nil with:' No hay na PEPE!!']
		ifNotNil:[
			doc owner:'pepe'.
			Array with:doc with:' To pa PEPE!!'].
		
		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/16/2012 16:10'!
initValidator
self validateDocUpdate:
	[:newDoc :savedDoc :userContext|
		self field:'owner' shouldBe:userContext name.
		self assert:[newDoc includesKey:'_id'].		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/6/2012 09:53'!
initViews
self addViewAt:'arguments'	
	put:
	[:doc|
		((doc at:'type')='argument') ifTrue:[
			self emit:doc key:(doc at:'aTag')
		]
	].


self addViewAt:'decisionsEdit'	
	put:
	[:doc |
	"view for decisions edition template"
		((doc at:'type')='decision') ifTrue:[
 	   		self emit:doc key: (doc at:'_id')
 	 	] 
	].


self addViewAt:'decisions'	
	put:[:doc| 
	|e|

	  ((doc  at:'type') ='decision') ifTrue:[
		e:=JsonObject new.
		e type:(doc at:'type');
		  description:(doc at:'description');
		  timesEvaluated:(doc at:'timesEvaluated').
		self emit: e key: (doc at:'_id').
	  ].
	"view for decisions list in the portal template"
].
self addViewAt:'dictionary'	
	put:[:doc| 
	((doc at:'type')='translation') ifTrue:[
		self emit:(doc at:'type') key:(Array with:(doc at:'language') with:(doc at:'of') with:(doc at:'text'))]
			]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/28/2012 11:24'!
initialize
super initialize.

self language:'smalltalk'.
self initLists.
self initShows.
self initViews.
self initFilters.
self initUpdates.
self initValidator.
"TODO: multipart does not work yet"
self halt.
self includeDocs:true.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'95t5boru'.
self upload.
! !

!SCouchDBApp class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 12:57'!
fromDictionary:aDic on:aViewServer
| a |
a:=super fromDictionary:aDic.
a server:aViewServer.
^a! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/25/2012 11:43'!
addEvently:anEventlyObject
|selectors eventName cutOn  i|

eventName:= anEventlyObject name asString.
i:=1.
cutOn:=1.
eventName do:[:aChar|
	(aChar isUppercase and: [i > 1 and:[cutOn=1]]) ifTrue:[
		cutOn:= i.
		].
	i:=i+1.
	].

eventName:= eventName copyFrom: cutOn to: eventName size. 
eventName at: 1 put: (eventName at: 1) asLowercase.
(eventName = 'init') ifTrue:[eventName:='_init'].
(eventName = 'changes') ifTrue:[eventName:='_changes'].

self evently at:(eventName) put: anEventlyObject instance! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/20/2012 19:40'!
addFilterAt:name put:aFilter
self at:'filters' ifAbsent:[self at:'filters' put: JsonObject new].
(self at:'filters') at:name put: aFilter .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/20/2012 19:40'!
addListAt:name put:aList
self at:'lists' ifAbsent:[self at:'lists' put: JsonObject new].
(self at:'lists') at:name put: aList .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 6/19/2012 11:41'!
addMustacheTemplate:aTemplate
self templates at:(aTemplate name asString) put:(aTemplate instance render)! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/20/2012 19:40'!
addShowAt:name put:aShow
(self at:'shows') ifNil:[self at:'shows' put:(JsonObject new)].
(self at:'shows') at:name put: aShow.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 11:01'!
addSignatureAt:name put:aSignature
self at:'signatures' ifAbsent:[ self at: 'signatures' put: JsonObject new].
(self at:'signatures') at:name put:aSignature.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/20/2012 19:41'!
addUpdateHandlerAt:name put:anUpdater
self at:'updates' ifAbsent:[self at:'updates' put: JsonObject new].
(self at:'updates') at:name put: anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMariAguirre 5/15/2012 22:03'!
addViewAt:name put:aView

self addViewAt:name put:aView  reduce:nil! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/20/2012 19:41'!
addViewAt:name put:aView reduce:aReduceFunction
|v aViewCode aReduceCode|
self at:'views' ifAbsent:[ self at:'views' put: JsonObject new].
v:=JsonObject new.
aViewCode:= (aView isKindOf: BlockClosure) 
				ifTrue:[aView]
				ifFalse:[aView asString ].

v map:(aViewCode).

aReduceCode:= (aReduceFunction isKindOf: BlockClosure) 
				ifTrue:[aReduceFunction]
				ifFalse:[aReduceFunction asString ].
aReduceFunction ifNotNil:[v at:'reduce' put:(aReduceCode)].
(self at:'views') at:name put:v.
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/28/2012 11:29'!
appName
	appName ifNil:[appName:= self class asString translateToLowercase ].
	^ appName! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 14:32'!
appName: anObject
	appName := anObject! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 8/21/2012 15:46'!
connectTo:aHost port:aPort userName:aUserName password:aPassword

dbAdaptor:=SCouchDBAdaptor new host: aHost port: aPort userName:aUserName password:aPassword.
"include the app in the CouchViewServer cache"
SCouchDBViewServer servers do:[:aServer| 
	aServer designDocs at:('_design/', self appName) put:self ]


	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 17:42'!
database
	database ifNil:[database:=self class asString asLowercase].
	^ database! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 12:18'!
database: anObject
	database := anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 6/15/2012 12:38'!
evently
^ self at:'evently' ifAbsent:[self at:'evently' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:17'!
filters
^ self at:'filters' ifAbsent:[self at:'filters' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:50'!
importAllAttachmentsFrom:aFolderPath
self importAllAttachmentsFrom:aFolderPath relPath:'' prefix:''
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importAllAttachmentsFrom:aFolderPath relPath:relPath prefix: aPrefix
| dir a elements attchPath |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllAttachmentsFrom:aFolderPath relPath:(entry name) prefix:aPrefix]
			ifFalse:[	self importAllAttachmentsFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name) prefix:aPrefix]
	]
	ifFalse:[
		
	
		a :=SCouchDBAttachment fromFile: (aFolderPath,relPath , FileDirectory pathNameDelimiter asString, entry name) includeDoc:self includeDocs. 

		(relPath='') 
			ifFalse:[attchPath:=(relPath , FileDirectory pathNameDelimiter asString, entry name)]
			ifTrue:[attchPath:=( entry name)].
		attchPath:= attchPath copyReplaceAll: '\' with: '/'.
		a name:  attchPath.
		self addAttachmentAt: (aPrefix,attchPath) put: a  

	]
]
! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 02:14'!
importAllEventlyFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self evently! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 5/26/2012 18:54'!
importAllTemplatesFrom:aFolderPath 
self importAllTemplatesFrom:aFolderPath relPath:''! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/12/2012 10:54'!
importAllTemplatesFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllTemplatesFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllTemplatesFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		(relPath='') 
			ifFalse:[
				attchPath:=(relPath , FileDirectory pathNameDelimiter asString, fileName).
				attchPath:= attchPath copyReplaceAll: '\' with: '/'.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self partials at: attchPath put: (aStream contents)
				]
			ifTrue:[
				attchPath:= fileName.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self templates at: attchPath put: (aStream contents)
				].
	]
]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:36'!
importVendorFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self vendor! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importVendorFilesFrom:aFolderPath relPath:relPath stack:currentJsonObject
| dir a elements attchPath fileName aStream aTempl |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		((entry name) = '_attachments') 
		ifTrue:[
			self importAllAttachmentsFrom: (aFolderPath , relPath , FileDirectory pathNameDelimiter asString, entry name) relPath:'' prefix: (('vendor',relPath,'/' ) copyReplaceAll: '\' with: '/').
			]
		ifFalse:[
			currentJsonObject at: entry name put: JsonObject new.
			self importVendorFilesFrom:aFolderPath 
				relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)
				stack:(currentJsonObject at: entry name).]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
		currentJsonObject at: fileName put: (
			 [Json readFrom: (SCouchUTF8Stream on: aStream)]
						on:Exception 
						do:[aStream contents]
			)
	]
]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs
^includeDocs! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs:aBool
includeDocs:=aBool! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 7/17/2012 16:05'!
initialize:size
super initialize:size.
includeDocs:=false.
self language:'smalltalk'.
self includeDocs: true.
self initialize
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language
	^self at:'language'! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language: anObject
	self at:'language' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/30/2012 09:08'!
lib
^ self at:'lib' ifAbsent:[self at:'lib' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:28'!
lib: anObject
	self at:'lib' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:05'!
lists
^ self at:'lists' ifAbsent:[self at:'lists' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/26/2012 16:58'!
partials
| templates |
templates:= self at:'templates' ifAbsent:[self at:'templates' put:(JsonObject new)].
^ templates at:'partials' ifAbsent:[(self at:'templates') at:'partials' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:01'!
removeFilter:aFilter

(self at:'filters' ) removeKey:aFilter.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:56'!
removeList:aList

(self at:'lists' ) removeKey:aList.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeShow:aShow
(self at:'shows' ) removeKey:aShow! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeSignature:aSignature
(self at:'signatures' ) removeKey:aSignature! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:56'!
removeUpdateHandler:anUpdater

(self at:'updates' ) removeKey:anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeView:aView
(self at:'views' ) removeKey:aView.! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/21/2012 16:23'!
runner
	^self
	"runner ifNil:[
		runner:=(SCouchDBFunCollection on:server).
		runner ddoc:self
	].
	
	^ runner"! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:06'!
shows
^ self at:'shows' ifAbsent:[self at:'shows' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/26/2012 16:50'!
templates
^ self at:'templates' ifAbsent:[self at:'templates' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:21'!
updates
^ self at:'updates' ifAbsent:[self at:'updates' put: JsonObject new].
! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMariAguirre 5/14/2012 15:44'!
upload
|db attchs |
dbAdaptor ifNil:[^nil].
db:=dbAdaptor ensureDatabase: self database.
db documentAt:('_design/', self appName) put: self.



	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/28/2012 16:56'!
validateDocUpdate
	^ self at:'validate_doc_update' ifAbsent:[self at:'validate_doc_update' put:'[]']! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/20/2012 19:42'!
validateDocUpdate: anObject
	self at:'validate_doc_update' put: anObject ! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/31/2012 01:37'!
vendor
^ self at:'vendor' ifAbsent:[self at:'vendor' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:20'!
views
^ self at:'views' ifAbsent:[self at:'views' put:(JsonObject new)]! !

SCouchDBApp subclass: #Tutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test-Evently'!

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 18:57'!
initEvently

self addEvently: TutorialItems.
self addEvently: TutorialChoices.
self addEvently: TutorialExamples.
! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 06:19'!
initViews
self addViewAt: 'toppings' put:[:doc|
	((doc at:'type' ifAbsent:[nil])= 'topping') ifTrue: [
			self emit:(doc at:'contents') key:nil.
		]
	] ! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/18/2012 01:37'!
initialize
super initialize.
self initEvently.
self initViews.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\tutorial\attachments\'.
"self importAllEventlyFilesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\tutorial\evently\'."
self connectTo:'localhost' port:5984 userName:'admin' password:'95t5boru'.
self upload.! !

WAComponent subclass: #JQSCouchDBTest
	instanceVariableNames: 'textInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Test'!

!JQSCouchDBTest class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:12'!
canBeRoot
^true! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/24/2012 19:01'!
renderContentOn:html
"self requestContext response headers at:'Access-Control-Allow-Origin' put:'"
html heading:'Demo CouchDB'.
self renderCouchInitOn:html.
self renderDocOn:html! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/24/2012 18:03'!
renderCouchInitOn:html

	html script:(
		html jQuery ready:(
			html jQuery couch login:'admin' password:'95t5boru' ;onSuccess: 'alert(''connected!!!!'')')
		)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/25/2012 18:27'!
renderCouchSaveDocOn:js content:aWord

	js add: (js jQuery couch db:'test';saveDoc: ('{"word":"', aWord,'"}')) 
	
		! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/24/2012 19:17'!
renderDocOn:html
 self
      renderLabel: 'Text-Input'
      control: [ :id :script |
         html textInput
            id: id;
            value: textInput;
            callback: [ :value | textInput := value ];
            onChange: (script html: [ :h | h render: textInput ]).
         "the following code checks if a manual submit does a correct encoding:"
         html submitButton
            onClick: (html jQuery ajax
               callback: [ :value | textInput := value ] 
		   value: (html jQuery id: id) value;
               script: [ :s | self renderCouchSaveDocOn: s content: textInput]);
            with: 'Manual Submit'.
         html button
            with: 'connect' ]
      model: textInput
      on: html
! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:06'!
renderLabel: aString control: aBlock model: anObject on: html
   | id |
   html fieldSet: [
      html label
         for: (id := html nextId);
         with: aString.
      html span: [
         aBlock
            value: id
            " update the paragraph "
            value: ((html jQuery this	
               parents: 'fieldset';
               find: 'p') load
                  " serialize all nearby form elements "
                  serialize: (html jQuery this		
                     parents: 'span';
                     find: ':input')) ].
      html paragraph: anObject ]
! !

!BlockClosure methodsFor: '*scouchdb-application' stamp: 'JesusMari 7/27/2012 21:27'!
sourceCode
|sc|

sc:= self decompile asString.
((sc at:1) = ${) ifTrue:[
	^ sc copyFrom:2 to: (sc size - 1)
	].
^ sc! !
